#!/bin/sh
#
# init camera in user space
#

FW_SENSOR_FILE=/var/log/fw_sensor_pncode

[ -f $FW_SENSOR_FILE ] || exit 0

. $FW_SENSOR_FILE

case "$FW_SENSOR" in
	0n )
		echo "$0: Initialize tw9900 and mdin27x for NTSC"
		/opt/nss/bin/tw9900_mdin27x -n
		;;
	0p )
		echo "$0: Initialize tw9900 and mdin27x for PAL"
		/opt/nss/bin/tw9900_mdin27x -p
		;;
	0N )
		echo "$0: Initialize tw9900 and mdin325 for NTSC"
		/opt/nss/bin/tw9900_mdin325 -n
		;;
	0P )
		echo "$0: Initialize tw9900 and mdin325 for PAL"
		/opt/nss/bin/tw9900_mdin325 -p
		;;
	*)
		echo "$0: Skip initialization TW9900"
		;;
esac

exit 0
