#!/bin/sh

source /etc/profile

###################################################################################
#Function : log()
#==================================================================================
function log() {
	printf "[$(date '+%Y.%m.%d-%H:%M:%S')] $* \n" >> $OEM_DEF_INIT_LOG
	printf "[$(date '+%Y.%m.%d-%H:%M:%S')] $* \n" >&2
}

###################################################################################
#Function : get_oem_code()
#==================================================================================
function get_oem_code() {
	local PNCODE=`grep SYF_STR1 /proc/driver/sy_basic_conf`
#	echo "$PNCODE"
	local OEM_PNCODE=${PNCODE:39:2}
	local OEM_PNCODE_SZ=${#OEM_PNCODE}
	log "OEM_PNCODE:$OEM_PNCODE"
	log "OEM_PNCODE_SZ:$OEM_PNCODE_SZ"
	if [ $OEM_PNCODE_SZ -lt 2 ]; then
		log "Wrong OEM code : $"
	fi

	printf "$OEM_PNCODE" >&1

	return 0;
}

CurrentOEMCode="$(get_oem_code)"
echo "CurrentOEMCode: $CurrentOEMCode"
printf "Set OEM Configuration: "
case $CurrentOEMCode in
	1y ) # AnO Onvif Disable(Alpha&Omega)
        mv /web/onvif/device_service.cgi /web/onvif/disable_device_service.cgi;
        mv /opt/nss/bin/m_rtspd /opt/nss/bin/disable_m_rtspd;
        mv /opt/nss/bin/rtspd /opt/nss/bin/disable_rtspd;
        mv /opt/nss/bin/rtspmg /opt/nss/bin/disable_rtspmg;
        ;;
esac

printf "OEM Daemon initialization done\n"