#!/bin/sh
#############################################################################################################################
# /usr/local/bin/init_sta_mode.sh
#############################################################################################################################

source /etc/profile
source /usr/local/bin/fw_common.sh
source /usr/local/bin/wifi_common.sh

function kill_bg_procs() {
	kill_proc hostapd
	kill_proc dnsmasq
	kill_wpa_supplicant

	$ECHO "bg procs killed for station mode"
}

function run_wpa_supplicant() {
	/usr/bin/systemctl restart wpa_supplicant
}

##### STA Mode  
INPUT_ARGS="$*"

DOWN_WLAN_DRIVER=0
F_RELOAD_NET_DRV=0
for i in ${INPUT_ARGS} ;do
	if [ "$i" == "-down" ]; then
		DOWN_WLAN_DRIVER=1;
	fi
	if [ "$i" == "-f" ]; then
		F_RELOAD_NET_DRV=1;
	fi
done

if [ $F_RELOAD_NET_DRV -eq 0 ]; then
	WIFI_TYPE=`get_wifi_type`
	if [ $WIFI_TYPE == "$WIFI_TYPE_NONE" ]; then
		echo "wifi type($WIFI_TYPE) does not support wifi"
		exit 0
	fi
	if [ $DOWN_WLAN_DRIVER -eq 0 ]; then
		WLAN_MODE=`get_wlan_mode`
		if [ "$WLAN_MODE" == "$WLAN_MODE_STATION" ]; then
			echo "already station mode"
			exit 0
		fi
	fi
fi

set_wlan_mode $WLAN_MODE_STATION
kill_bg_procs
LSMOD_BCMDHD=`/sbin/lsmod | /bin/grep bcmdhd`
if [ "$LSMOD_BCMDHD" != "" ]; then
	down_bcmdhd_driver
fi

if [ $DOWN_WLAN_DRIVER -eq 1 ];then
	set_wlan_mode $WLAN_MODE_DOWN
	exit 0
fi

up_bcmdhd_driver
run_wpa_supplicant
sleep 5

exit 0
