#!/bin/sh

. /etc/profile

function add_log() {
    local description="$1"
    fwlogctl add -c 10 -t 4 -d "$description"
}

function start_update() {
    local filename="$1"
    if [ -z $1 ] || [ ! -f $filename ]; then
        echo "No input file: $1"
        return -1
    fi

    echo "/opt/nss/bin/stm32flash -w $filename -v -V2 /dev/ttyS1"
    /opt/nss/bin/stm32flash -w $filename -v -V2 /dev/ttyS1
}

function finish_update() {
    local filename="$1"
    local result=$2
    local bname=`basename $filename`

    local description
    if [ ! -z $result ] && [ $result -eq 0 ]; then
        description="Success to update PTZ ($bname)."
    else
        description="Fail to update PTZ ($bname)."
    fi
    add_log "$description"

    rm -f $filename
    reboot
    sync
}

COMMAND=$1
PTZ_FILENAME="$2"

if [ "$COMMAND" == "start" ]; then
    start_update "$2"
elif [ "$COMMAND" == "finish" ]; then
    RESULT=$3
    finish_update "$2" $RESULT
fi
