#!/bin/sh
##
## History:
##	2015/04/28 - [Tao Wu] modify file
##
##
## Copyright (c) 2016 Ambarella, Inc.
##
## This file and its contents ("Software") are protected by intellectual
## property rights including, without limitation, U.S. and/or foreign
## copyrights. This Software is also the confidential and proprietary
## information of Ambarella, Inc. and its licensors. You may not use, reproduce,
## disclose, distribute, modify, or otherwise prepare derivative works of this
## Software or any portion thereof except pursuant to a signed license agreement
## or nondisclosure agreement with Ambarella, Inc. or its authorized affiliates.
## In the absence of such an agreement, you agree to promptly notify and return
## this Software to Ambarella, Inc.
##
## THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
## INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
## MERCHANTABILITY, AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
## IN NO EVENT SHALL AMBARELLA, INC. OR ITS AFFILIATES BE LIABLE FOR ANY DIRECT,
## INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
## (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
## LOSS OF USE, DATA, OR PROFITS; COMPUTER FAILURE OR MALFUNCTION; OR BUSINESS
## INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
## CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
## ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
## POSSIBILITY OF SUCH DAMAGE.
##


DIR_CONFIG=/tmp/config
WPA_CONFIG=$DIR_CONFIG/wpa_supplicant.conf
COOEE_CONFIG=$DIR_CONFIG/cooee.conf
DEVICE=wlan0

SSID=""
PASSWORD=""

if [ -f $WPA_CONFIG ]; then
	wifi_setup.sh sta nl80211
else
	mkdir -p $DIR_CONFIG
	ifconfig  $DEVICE up
	while [ ! -f $COOEE_CONFIG ]
	do
		echo "Cooee..."
		cooee -f $COOEE_CONFIG
	done
	echo "Cooee Done"

	SSID=$(grep ssid ${COOEE_CONFIG} | cut -c 6-)
	PASSWORD=$(grep password ${COOEE_CONFIG} | cut -c 10-)
	echo "Cooee: SSID=${SSID}, PASSWORD=${PASSWORD}"
	wifi_setup.sh sta nl80211 "${SSID}" "${PASSWORD}"
fi
########################################
