<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
	<style type="text/css">
        html, body { height: 100%; }
        html { display: table; margin: auto; }
        body { display: table-cell; vertical-align: middle; }
	</style>
</head>
<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
    <video id="id_image" muted="muted" loop="loop" src="" type="video/mp4" autoplay></video>
    <iframe src="" name=SetCgi frameborder="0" width="0" height="0" marginwidth="0" marginheight="0" scrolling="no"></iframe>
<script src="/js/jquery-3.6.0.min.js" type="text/javascript"></script>
<script src="/js/websocket/event.js" type="text/javascript"></script>
<script src="/js/websocket/jpegusr.js" type="text/javascript"></script>
<script src="/js/websocket/remuxer.js" type="text/javascript"></script>
<script src="/js/websocket/mp4.js" type="text/javascript"></script>
<script src="/js/websocket/videoconverter.js" type="text/javascript"></script>
<script language="javascript" type="text/javascript">
    var IP = document.location.hostname;
    var PORT = document.location.port;
    const listener = Symbol("event_listener");
    const listeners = Symbol("event_listeners"); 
    var ClientEventSource;
    var WebsockQueues={}; WebsockQueues[1]=[]; //video h.264
    var mimeType;
    var wsUri;
    var WebsockStatus = 0;
    var FirstWebsockFlag = 1;
    var IframeFlag = false;
    if (document.location.protocol == 'https:')
    {
        wsUri = "wss://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&PauseTime=0&FwCgiVer=0x0001";
    }
    else
    {
        wsUri = "ws://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&PauseTime=0&FwCgiVer=0x0001";
    }

    const element = document.getElementById('id_image');
    var Converter;
    <% FwFrameRateGet("FwModId","PortId"); %>
    var WebSockVideoStreamFps = STREAM_FRAMERATE;
    var FlushHandler;
    var FlushInverval = Math.floor(1000 / WebSockVideoStreamFps);
    var client_eventSource = new EventEmitter();
    var RawImage;

    window.addEventListener("load", Init, false);

    function Flush() {
        for (let qidx in WebsockQueues) 
        {
            let RawImageQueue = WebsockQueues[qidx];
            while (RawImageQueue.length) 
            {
                RawImage = RawImageQueue.shift();
                if (RawImage)
                {
                    Converter.appendRawData(RawImage);
                    Converter.play();
                }          
            }
        }
    }

    function StartStreamFlush() {
        FlushHandler = setInterval(()=>{
            client_eventSource.dispatchEvent('Flush');
        }, FlushInverval);
    }

    function Init() {
        websocket = new WebSocket(wsUri,["wjes"]);
        websocket.onopen = function(evt) { onOpen(evt) };
        websocket.onclose = function(evt) { onClose(evt) };
        websocket.onmessage = function(evt) { onMessage(evt) };
        websocket.onerror = function(evt) { onError(evt) };

        ClientEventSource = new EventSourceWrapper(client_eventSource);
        ClientEventSource.on('Flush', Flush.bind(this));
        StartStreamFlush();
    }

    function onOpen(evt) {
        doSend("GET /cgi-bin/fwstream.cgi?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&PauseTime=0&FwCgiVer=0x0001 HTTP/1.1\r\nHost: " + IP + "\r\nConnection: keep-alive\r\nUpgrade-Insecure-Requests: 1\r\nUser-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/89.0.4389.90 Safari/537.36\r\nAccept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9\r\nAccept-Encoding: gzip, deflate\r\nAccept-Language: ko-KR,ko;q=0.9,en-US;q=0.8,en;q=0.7\r\n\r\n");
    }

    function onClose(evt) {

    }

    function onMessage(evt)
    {
        switch(WebsockStatus)
        {
            case -1:
                break;
            case 0:
                onAuthMessage(evt);
                break;
            case 1:
                onJesMessage(evt);
                break;
        }
    }

    function onAuthMessage(evt)
    {
        var AuthJsonResponse = evt.data;
        try {
            var AuthJsonParse = JSON.parse(AuthJsonResponse);
            //console.log("response_code : " + AuthJsonParse.response_code);
            //console.log("auth : " + AuthJsonParse.auth);
            //console.log("realm : " + AuthJsonParse.realm);
            //console.log("nonce : " + AuthJsonParse.nonce);
            document.all.SetCgi.src = "/web/cgi-bin/admin/ws_adminauth.cgi?ResponseCode=" + AuthJsonParse.response_code + "&Auth=" + AuthJsonParse.auth + "&Realm=" + AuthJsonParse.realm + "&Nonce=" + AuthJsonParse.nonce +  "&FwCgiVer=0x0001";
            WebsockStatus = 1;
        } catch {
            WebsockStatus = -1;
        } finally {
            switch(WebsockStatus)
            {
                case -1:
                    alert("Websocket authentication failed, Please reconnect again.");
                    break;
                default:
                    break;
            }
        }
    }

    function onJesMessage(evt)
    {
        var arrayBufferView = new Uint8Array( evt.data );

        let jes_data = new jpeg_usr_t(arrayBufferView);

        if(jes_data.isKeyframe()) IframeFlag = true;

        if ( FirstWebsockFlag == 1 )
        {
            if (jes_data.codec_type == "H.265")
            {
                alert("H.265 is not surported, Please change another Encoding.");
            }

            if (jes_data.codec_type == "H.264")
            {
                if( jes_data.isKeyframe() )
                {
                    //console.log("isKeyframe !!");
                    mimeType = "video/mp4; codecs=" + jes_data.codec;
                    Converter = new VideoConverter(element, WebSockVideoStreamFps, 1);
                    FirstWebsockFlag = 0;
                }
            }

            if (jes_data.codec_type == "MJPEG")
            {
                $("video").replaceWith("<img id='id_image' src=''></img>");
                FirstWebsockFlag = 0;
            }
        }

        if (jes_data.codec_type == "H.264")
        {
            if(IframeFlag)
            {
                WebsockQueues[1].push(jes_data);
            }
        }
        else if (jes_data.codec_type == "MJPEG")
        {
            $("video").replaceWith("<img id='id_image' src=''></img>");
            var reader<% FwGetParmValue("PortId"); %> = new FileReader();
            reader<% FwGetParmValue("PortId"); %>.onload = function (evt) {
                if (evt.target.readyState == FileReader.DONE) {
                    var url = evt.target.result;
                    document.getElementById("id_image").src = url;
                }
            }

            var arrayBufferView = new Uint8Array(evt.data);
            var blob = new Blob([arrayBufferView], { type: "image/jpeg" });
            reader<% FwGetParmValue("PortId"); %>.readAsDataURL(blob);
            blob = null;
            arrayBufferView = null;
            reader<% FwGetParmValue("PortId"); %> = null;
        }

        DrawArea();
        jes_data = null;
    }

    function onError(evt)
    {

    }

    function doSend(message)
    {
        var bytearray = new Uint8Array( message.length );
        
        websocket.binaryType = 'arraybuffer';
        for ( var idx = 0; idx < message.length; ++idx )
        {
            bytearray[idx] = message[idx].charCodeAt(0);
        }
        websocket.send(bytearray.buffer);
    }

    // holds all our areas
    var areas = [];

    // New, holds the 8 tiny areas that will be our selection handles
    // the selection handles will be in this order:
    // 0  1 
    // 3  2 
    var selectionHandles = [];

    // Hold canvas information
    var canvas;
    var ctx;
    var WIDTH = 512;
    var HEIGHT = 350;

    var isDrag = false;
    var isResizeDrag = false;
    var expectResize = -1; // New, will save the # of the selection handle if the mouse is over one.
    var mx, my; // mouse coordinates

    // when set to true, the canvas will redraw everything

    // The node (if any) being selected.
    // If in the future we want to select multiple objects, this will get turned into an array
    var mAreaSel = null;

    // The selection color and width. Right now we have a red selection with a small width

    var mAreaColor = "#ff0000";
    var mArrowColor = "#ff0000";
    var mStringColor = "#ffff00";
    var mAreaBoxColor = 'rgba(0,255,0,0.5)'; // New for selection areas
    var mAreaWidth = 2;
    var mSelBoxSize = 6;
    var mArrowWidth = 3;

    // we use a fake canvas to draw individual shapes for selection testing
    var ghostcanvas;
    var gctx; // fake canvas context

    // since we can drag from anywhere in a node
    // instead of just its x/y corner, we need to save
    // the offset of the mouse when we start dragging.
    var offsetx0, offsety0, offsetx1, offsety1, offsetx2, offsety2, offsetx3, offsety3 ;

    // Padding and border style widths for mouse offsets
    var stylePaddingLeft, stylePaddingTop, styleBorderLeft, styleBorderTop;

    // Area object to hold data
    function Area() {
        this.mode = 0;
        this.arrowtype = 0;
        this.en = 0;
        this.x0 = 0;
        this.y0 = 0;
        this.x1 = 0;
        this.y1 = 0;
        this.x2 = 0;
        this.y2 = 0;
        this.x3 = 0;
        this.y3 = 0;
        this.dr = 0;
    }

    function getAngle(x1,y1,x2,y2) {
        let a;
        if(y1 == y2)
        {
            if(x2<x1) {
                a = -90;
            } else {
                a = 90;
            }
        } else if(x1==x2 && y2>y1) {
            a = 180;
        } else {
            const rad = Math.atan((x2-x1)/(y1-y2));
            a = rad * 180 / Math.PI;
            
            if(y2>y1 && x2>x1) {
                a = 180 + a;
            } else if(y2>y1 && x2<x1) {
                a = -180 + a;
            }
        }
        return a;
    }

    function drawArrow(ctx, fromx, fromy, tox, toy, arrowWidth, color){
        //variables to be used when creating the arrow
        var headlen = 10;
        var angle = Math.atan2(toy-fromy,tox-fromx);
    
        ctx.save();
        ctx.strokeStyle = color;
    
        //starting path of the arrow from the start square to the end square
        //and drawing the stroke
        ctx.beginPath();
        ctx.moveTo(fromx, fromy);
        ctx.lineTo(tox, toy);
        ctx.lineWidth = arrowWidth;
        ctx.stroke();
    
        //starting a new path from the head of the arrow to one of the sides of
        //the point
        ctx.beginPath();
        ctx.moveTo(tox, toy);
        ctx.lineTo(tox-headlen*Math.cos(angle-Math.PI/7),
                toy-headlen*Math.sin(angle-Math.PI/7));
    
        //path from the side point of the arrow, to the other side point
        ctx.lineTo(tox-headlen*Math.cos(angle+Math.PI/7),
                toy-headlen*Math.sin(angle+Math.PI/7));
    
        //path from the side point back to the tip of the arrow, and then
        //again to the opposite side point
        ctx.lineTo(tox, toy);
        ctx.lineTo(tox-headlen*Math.cos(angle-Math.PI/7),
                toy-headlen*Math.sin(angle-Math.PI/7));
    
        //draws the paths created above
        ctx.stroke();
        ctx.restore();
    }

    // New methods on the Area class
    Area.prototype.area_draw = function (context, optionalColor) {
        // we used to have a solo draw function
        // but now each area is responsible for its own drawing
        // mainDraw() will call this with the normal canvas
        // mDown will call this with the ghost canvas with 'black'
        context.fillStyle = this.fill;
        // We can skip the drawing of elements that have moved off the screen:
        
        if (this.x > WIDTH || this.y > HEIGHT) return;

        context.beginPath();
        context.moveTo(this.x0, this.y0);
        context.lineTo(this.x1, this.y1);
        context.lineTo(this.x2, this.y2);
        context.lineTo(this.x3, this.y3);
        context.closePath();
        context.fill();

        // draw selection
        // this is a stroke along the area and also 8 new selection handles
        if (mAreaSel === this) {
            context.strokeStyle = mAreaColor;
            context.lineWidth = mAreaWidth;
            context.stroke();

            // draw the areas

            var half = mSelBoxSize / 2;

            // 0  1 
            // 3  2 

            // top left, middle, right
            selectionHandles[0].x = this.x0 - half;
            selectionHandles[0].y = this.y0 - half;

            selectionHandles[1].x = this.x1 - half;
            selectionHandles[1].y = this.y1 - half;

            selectionHandles[2].x = this.x2 - half;
            selectionHandles[2].y = this.y2 - half;

            selectionHandles[3].x = this.x3 - half;
            selectionHandles[3].y = this.y3 - half;

            context.fillStyle = mAreaBoxColor;
            for (var idx = 0; idx < 4; idx++) {
                var curHandle = selectionHandles[idx];
                context.fillRect(curHandle.x, curHandle.y, mSelBoxSize, mSelBoxSize);
            }
        }
    }

    Area.prototype.arrow_draw = function (context, optionalColor) {
        // we used to have a solo draw function
        // but now each area is responsible for its own drawing
        // mainDraw() will call this with the normal canvas
        // mDown will call this with the ghost canvas with 'black'
        context.fillStyle = this.fill;
        // We can skip the drawing of elements that have moved off the screen:
        
        if (this.x > WIDTH || this.y > HEIGHT) return;

        drawArrow(context, this.x0, this.y0, this.x1, this.y1, 3, 'red');

        context.strokeStyle = mArrowColor;
        context.lineWidth = mArrowWidth;
        context.stroke();

        var angle = getAngle(this.x0, this.y0, this.x1, this.y1);
        //12~3
        if ( angle == 0 )
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;

            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2) - 25, ((this.y0 + this.y1)/2) );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2) + 15, ((this.y0 + this.y1)/2) );

        }
        else if ( angle > 0 && angle < 45 )
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2) - 25, ((this.y0 + this.y1)/2) );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2) + 15, ((this.y0 + this.y1)/2) );
        }
        else if ( angle == 45 )
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) + 15 );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) - 25 );
        }
        else if ( angle > 45 && angle < 90 )
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) - 15 );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) + 25 );
        }
        //3~6
        else if ( angle == 90 )
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) - 15 );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) + 25 );
        }
        else if ( angle > 90 && angle < 135 )
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) - 15 );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) + 25 );
        }
        else if ( angle == 135 )
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2) + 15, ((this.y0 + this.y1)/2) );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2) - 25, ((this.y0 + this.y1)/2) );
        }
        else if ( angle > 135 && angle < 180 )
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2) + 15, ((this.y0 + this.y1)/2) );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2) - 25, ((this.y0 + this.y1)/2) );
        }
        //6~9
        else if ( angle == 180)
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2) + 15, ((this.y0 + this.y1)/2) );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2) - 25, ((this.y0 + this.y1)/2) );
        }
        else if ( angle > -180 && angle < -135 )
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2) + 15, ((this.y0 + this.y1)/2) );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2) - 25, ((this.y0 + this.y1)/2) );
        }
        else if ( angle == -135)
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) + 25 );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) - 15 );
        }
        else if ( angle > -135 && angle < -90 )
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) + 25 );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) - 15 );
        }
        //9~12
        else if ( angle == -90)
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) + 25 );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) - 15 );
        }
        else if ( angle > -90 && angle < -45 )
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) + 25 );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2), ((this.y0 + this.y1)/2) - 15 ); 
        }
        else if ( angle == -45)
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2) - 25, ((this.y0 + this.y1)/2) );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2) + 15, ((this.y0 + this.y1)/2) );
        }
        else if ( angle > -45 && angle < 0 )
        {
            context.strokeStyle = mStringColor;
            context.lineWidth = 1;
            if (this.arrowtype == 1 || this.arrowtype == 3) context.strokeText("R", ((this.x0 + this.x1)/2) - 25, ((this.y0 + this.y1)/2) );
            if (this.arrowtype == 2 || this.arrowtype == 3) context.strokeText("L", ((this.x0 + this.x1)/2) + 15, ((this.y0 + this.y1)/2) );
        }

        context.strokeStyle = mArrowColor;
        context.lineWidth = mArrowWidth;

        // draw selection
        // this is a stroke along the area and also 8 new selection handles
        if (mAreaSel === this) {
            // draw the lines

            var half = mSelBoxSize / 2;

            // 0  1 
            // top left, middle, right
            selectionHandles[0].x = this.x0 - half;
            selectionHandles[0].y = this.y0 - half;

            selectionHandles[1].x = this.x1 - half;
            selectionHandles[1].y = this.y1 - half;

            context.fillStyle = mAreaBoxColor;
            for (var idx = 0; idx < 2; idx++) {
                var curHandle = selectionHandles[idx];
                context.fillRect(curHandle.x, curHandle.y, mSelBoxSize, mSelBoxSize);
            }
        }
    }

    //Initialize a new Area, add it, and invalidate the canvas
    function addRect(mode, arrowtype, x0, y0, x1, y1, x2, y2, x3, y3) {
        var rect = new Area;
        rect.en = 1;
        rect.mode = mode;
        rect.arrowtype = arrowtype;
        rect.x0 = x0;
        rect.y0 = y0;
        rect.x1 = x1;
        rect.y1 = y1;
        rect.x2 = x2;
        rect.y2 = y2;
        rect.x3 = x3;
        rect.y3 = y3;
        areas.push(rect);
    }

    // initialize our canvas, add a ghost canvas, set draw loop
    // then add everything we want to intially exist on the canvas
    
    function DrawArea() {
           
        canvas = $("#ViewerCanvas", parent.document)[0];
        ctx = canvas.getContext('2d');
        ctx.canvas.width = WIDTH;
        ctx.canvas.height = HEIGHT;

        var WebSockVideo = document.getElementById("id_image");
        ctx.drawImage(WebSockVideo, 0, 0, WIDTH, HEIGHT);

        ghostcanvas = document.createElement('canvas');
        ghostcanvas.width = WIDTH;
        ghostcanvas.height = HEIGHT;
        gctx = ghostcanvas.getContext('2d');

        //fixes a problem where double clicking causes text to get selected on the canvas
        canvas.onselectstart = function () { return false; }

        // fixes mouse co-ordinate problems when there's a border or padding
        // see getMouse for more detail
        if( document.defaultView && document.defaultView.getComputedStyle )
        {
            stylePaddingLeft = parseInt(document.defaultView.getComputedStyle(canvas, null)['paddingLeft'], 10) || 0;
            stylePaddingTop = parseInt(document.defaultView.getComputedStyle(canvas, null)['paddingTop'], 10) || 0;
            styleBorderLeft = parseInt(document.defaultView.getComputedStyle(canvas, null)['borderLeftWidth'], 10) || 0;
            styleBorderTop = parseInt(document.defaultView.getComputedStyle(canvas, null)['borderTopWidth'], 10) || 0;
        }

        // set our events. Up and down are for dragging,
        // double click is for making new areas
        canvas.onmousedown = mDown;
        canvas.onmouseup = mUp;
        canvas.onmousemove = mMove;

        // set up the selection handle areas
        for (var idx = 0; idx < 4; idx++) {
            var rect = new Area;
            selectionHandles.push(rect);
        }
        // add custom initialization here:
        if( parent.gFirstStreamFlag == "0" )
        {
            var Mode;
            var Direction;
            var ArrowType;

            for (var idx = 0; idx < parent.MAX_AREA_NUM; idx++) {
                    //init Polygon
                if (eval("parent.VA_FENCE_" + idx + "_EN") != "0")
                {
                    Mode = parseInt(eval("parent.VA_FENCE_" + idx + "_MODE"));
                    Direction = parseInt(eval("parent.VA_FENCE_" + idx + "_DR"));
                    if(Mode)    ArrowType = 0;
                    else        ArrowType = Direction;
                    addRect(parseInt(eval("parent.VA_FENCE_" + idx + "_MODE") ),
                            ArrowType,
                            parseInt(eval("parent.VA_FENCE_" + idx + "_X0") * 5.88), 
                            parseInt(eval("parent.VA_FENCE_" + idx + "_Y0") * 5.88), 
                            parseInt(eval("parent.VA_FENCE_" + idx + "_X1") * 5.88), 
                            parseInt(eval("parent.VA_FENCE_" + idx + "_Y1") * 5.88), 
                            parseInt(eval("parent.VA_FENCE_" + idx + "_X2") * 5.88), 
                            parseInt(eval("parent.VA_FENCE_" + idx + "_Y2") * 5.88), 
                            parseInt(eval("parent.VA_FENCE_" + idx + "_X3") * 5.88), 
                            parseInt(eval("parent.VA_FENCE_" + idx + "_Y3") * 5.88)) ;
                }
                    // should add init Tripwire here

            }
            parent.gFirstStreamFlag++;
        }

        ctx.fillStyle = mAreaBoxColor;
        ctx.strokeStyle = mAreaColor;
        ctx.lineWidth = 1;

        // Add stuff you want drawn in the background all the time here

        // draw all areas
        var Len = areas.length;
        for (var idx = 0; idx < Len; idx++) {
            if(areas[idx].mode == 1)
            {
                areas[idx].area_draw(ctx); // we used to call drawshape, but now each area draws itself
            }
            else if(areas[idx].mode == 0)
            {
                areas[idx].arrow_draw(ctx); // we used to call drawshape, but now each area draws itself
            }
        }
    }

    //wipes the canvas context
    function clear(c)
    {
        c.clearRect(0, 0, WIDTH, HEIGHT);
    }

    // Happens when the mouse is moving inside the canvas
    function mMove(e)
    {
        if (isDrag)
        {
            getMouse(e);
            mAreaSel.en = 1;
            mAreaSel.x0 = mx - offsetx0;
            mAreaSel.y0 = my - offsety0;
            mAreaSel.x1 = mx - offsetx1;
            mAreaSel.y1 = my - offsety1;
            mAreaSel.x2 = mx - offsetx2;
            mAreaSel.y2 = my - offsety2;
            mAreaSel.x3 = mx - offsetx3;
            mAreaSel.y3 = my - offsety3;
        }
        else if (isResizeDrag)
        {
            // time ro resize!
            // 0  1 
            // 3  2 
            switch (expectResize) {
                case 0:
                    mAreaSel.x0 = mx;
                    mAreaSel.y0 = my;
                    break;
                case 1:
                    mAreaSel.x1 = mx;
                    mAreaSel.y1 = my;
                    break;
                case 2:
                    mAreaSel.x2 = mx;
                    mAreaSel.y2 = my;
                    break;
                case 3:
                    mAreaSel.x3 = mx;
                    mAreaSel.y3 = my;
                    break;
            }
        }

        getMouse(e);
        // if there's a selection see if we grabbed one of the selection handles
        if (mAreaSel !== null && !isResizeDrag) {
            for (var idx = 0; idx < 4; idx++) {
                // 0  1 
                // 3  2 

                var curHandle = selectionHandles[idx];

                // we dont need to use the ghost context because
                // selection handles will always be rectangles
                if (mx >= curHandle.x && mx <= curHandle.x + mSelBoxSize &&
                    my >= curHandle.y && my <= curHandle.y + mSelBoxSize) {
                    // we found one!
                    expectResize = idx;
                    this.style.cursor = 'move';
                    return;
                }

            }
            // not over a selection area, return to normal
            isResizeDrag = false;
            expectResize = -1;
            this.style.cursor = 'auto';
        }

    }

    // Happens when the mouse is clicked in the canvas
    function mDown(e) {
        getMouse(e);

        //we are over a selection area
        if (expectResize !== -1) {
            isResizeDrag = true;
            return;
        }

        var Len = areas.length;
        for (var idx = Len - 1; idx >= 0; idx--) {

            if(areas[idx].mode == 1)
            {
                // draw shape onto ghost context
                areas[idx].area_draw(gctx, 'black');

                // get image data at the mouse x,y pixel
                var imageData = gctx.getImageData(mx, my, 1, 1);

                // if the mouse pixel exists, select and break
                if (imageData.data[3] > 0) {
                    mAreaSel = areas[idx];
                    offsetx0 = mx - mAreaSel.x0;
                    offsety0 = my - mAreaSel.y0;
                    offsetx1 = mx - mAreaSel.x1;
                    offsety1 = my - mAreaSel.y1;
                    offsetx2 = mx - mAreaSel.x2;
                    offsety2 = my - mAreaSel.y2;
                    offsetx3 = mx - mAreaSel.x3;
                    offsety3 = my - mAreaSel.y3;

                    mAreaSel.en = 1;
                    mAreaSel.x0 = mx - offsetx0;
                    mAreaSel.y0 = my - offsety0;
                    mAreaSel.x1 = mx - offsetx1;
                    mAreaSel.y1 = my - offsety1;
                    mAreaSel.x2 = mx - offsetx2;
                    mAreaSel.y2 = my - offsety2;
                    mAreaSel.x3 = mx - offsetx3;
                    mAreaSel.y3 = my - offsety3;
                    isDrag = true;
                    return;
                }
            }
            else if(areas[idx].mode == 0)
            {
                // draw shape onto ghost context
                areas[idx].arrow_draw(gctx, 'black');

                // get image data at the mouse x,y pixel
                var imageData = gctx.getImageData(mx, my, 1, 1);

                // if the mouse pixel exists, select and break
                if (imageData.data[3] > 0) {
                    mAreaSel = areas[idx];
                    offsetx0 = mx - mAreaSel.x0;
                    offsety0 = my - mAreaSel.y0;
                    offsetx1 = mx - mAreaSel.x1;
                    offsety1 = my - mAreaSel.y1;

                    mAreaSel.en = 1;
                    mAreaSel.x0 = mx - offsetx0;
                    mAreaSel.y0 = my - offsety0;
                    mAreaSel.x1 = mx - offsetx1;
                    mAreaSel.y1 = my - offsety1;
                    isDrag = true;
                    return;
                }
            }
        }
        // havent returned means we have selected nothing
        mAreaSel = null;
    }

    function mUp() {
        isDrag = false;
        isResizeDrag = false;
        expectResize = -1;
    }

    // adds a new node
    function New() {
        if (areas.length > (parent.MAX_AREA_NUM - 1)) {
            alert("It is not possible to add area any more.");
            return false;
        }
        else {
            addRect(1, 0, 126, 86, 390, 86, 390, 259, 126, 259);
        }
    }

    function Delete() {
        var idx;
        var select_idx = -1;
        for( idx = 0; idx < (areas.length); idx++ )
        {
            if( areas[idx] == mAreaSel )
            {
                select_idx = idx;
                break;
            }
        }

        if ( select_idx == -1) {
            alert("Please, select area.");
            return false;
        }
        else {
            areas[select_idx].en = 0;
            areas.splice(select_idx, 1);
        }
    }

    function DeleteAll() {
        var idx;
        for( idx = 0; idx < areas.length; idx++ )
        {
            areas[idx].mode = 0;
            areas[idx].en = 0;
            areas[idx].x0 = 0;
            areas[idx].y0 = 0;
            areas[idx].x1 = 0;
            areas[idx].y1 = 0;
            areas[idx].x2 = 0;
            areas[idx].y2 = 0;
            areas[idx].x3 = 0;
            areas[idx].y3 = 0;
            areas[idx].dr = 0;
            areas.splice(idx, areas.length);
        }
    }

    // Sets mx,my to the mouse position relative to the canvas
    // unfortunately this can be tricky, we have to worry about padding and borders
    function getMouse(e) {
        var element = canvas, offsetX = 0, offsetY = 0;

        if (element.offsetParent) {
            do {
                offsetX += element.offsetLeft;
                offsetY += element.offsetTop;
            } while ((element = element.offsetParent));
        }

        // Add padding and border style widths to offset
        offsetX += stylePaddingLeft;
        offsetY += stylePaddingTop;

        offsetX += styleBorderLeft;
        offsetY += styleBorderTop;

        mx = e.pageX - offsetX;
        my = e.pageY - offsetY
    }

</script>
</html>
