<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
	<style type="text/css">
        html, body { height: 100%; }
        html { display: table; margin: auto; }
        body { display: table-cell; vertical-align: middle; }
	</style>
</head>
<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
    <video id="id_image" muted="muted" loop="loop" src="" type="video/mp4" autoplay></video>
    <iframe src="" name=SetCgi frameborder="0" width="0" height="0" marginwidth="0" marginheight="0" scrolling="no"></iframe>
<script src="/js/jquery-3.6.0.min.js" type="text/javascript"></script>
<script src="/js/websocket/event.js" type="text/javascript"></script>
<script src="/js/websocket/jpegusr.js" type="text/javascript"></script>
<script src="/js/websocket/remuxer.js" type="text/javascript"></script>
<script src="/js/websocket/mp4.js" type="text/javascript"></script>
<script src="/js/websocket/videoconverter.js" type="text/javascript"></script>
<script language="javascript" type="text/javascript">
    var IP = document.location.hostname;
    var PORT = document.location.port;
    const listener = Symbol("event_listener");
    const listeners = Symbol("event_listeners"); 
    var ClientEventSource;
    var WebsockQueues={}; WebsockQueues[1]=[]; //video h.264
    var mimeType;
    var wsUri;
    var WebsockStatus = 0;
    var FirstWebsockFlag = 1;
    var IframeFlag = false;
    if (document.location.protocol == 'https:')
    {
        wsUri = "wss://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&PauseTime=0&FwCgiVer=0x0001";
    }
    else
    {
        wsUri = "ws://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&PauseTime=0&FwCgiVer=0x0001";
    }

    const element = document.getElementById('id_image');
    var Converter;
    <% FwFrameRateGet("FwModId","PortId"); %>
    var WebSockVideoStreamFps = STREAM_FRAMERATE;
    var FlushHandler;
    var FlushInverval = Math.floor(1000 / WebSockVideoStreamFps);
    var client_eventSource = new EventEmitter();
    var RawImage;

    window.addEventListener("load", Init, false);

    function Flush() {
        for (let qidx in WebsockQueues) 
        {
            let RawImageQueue = WebsockQueues[qidx];
            while (RawImageQueue.length) 
            {
                RawImage = RawImageQueue.shift();
                if (RawImage)
                {
                    Converter.appendRawData(RawImage);
                    Converter.play();
                }          
            }
        }
    }

    function StartStreamFlush() {
        FlushHandler = setInterval(()=>{
            client_eventSource.dispatchEvent('Flush');
        }, FlushInverval);
    }

    function Init() {
        websocket = new WebSocket(wsUri,["wjes"]);
        websocket.onopen = function(evt) { onOpen(evt) };
        websocket.onclose = function(evt) { onClose(evt) };
        websocket.onmessage = function(evt) { onMessage(evt) };
        websocket.onerror = function(evt) { onError(evt) };

        ClientEventSource = new EventSourceWrapper(client_eventSource);
        ClientEventSource.on('Flush', Flush.bind(this));
        StartStreamFlush();
    }

    function onOpen(evt) {
        doSend("GET /cgi-bin/fwstream.cgi?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&PauseTime=0&FwCgiVer=0x0001 HTTP/1.1\r\nHost: " + IP + "\r\nConnection: keep-alive\r\nUpgrade-Insecure-Requests: 1\r\nUser-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/89.0.4389.90 Safari/537.36\r\nAccept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9\r\nAccept-Encoding: gzip, deflate\r\nAccept-Language: ko-KR,ko;q=0.9,en-US;q=0.8,en;q=0.7\r\n\r\n");
    }

    function onClose(evt) {

    }

    function onMessage(evt)
    {
        switch(WebsockStatus)
        {
            case -1:
                break;
            case 0:
                onAuthMessage(evt);
                break;
            case 1:
                onJesMessage(evt);
                break;
        }
    }

    function onAuthMessage(evt)
    {
        var AuthJsonResponse = evt.data;
        try {
            var AuthJsonParse = JSON.parse(AuthJsonResponse);
            //console.log("response_code : " + AuthJsonParse.response_code);
            //console.log("auth : " + AuthJsonParse.auth);
            //console.log("realm : " + AuthJsonParse.realm);
            //console.log("nonce : " + AuthJsonParse.nonce);
            document.all.SetCgi.src = "/web/cgi-bin/admin/ws_adminauth.cgi?ResponseCode=" + AuthJsonParse.response_code + "&Auth=" + AuthJsonParse.auth + "&Realm=" + AuthJsonParse.realm + "&Nonce=" + AuthJsonParse.nonce +  "&FwCgiVer=0x0001";
            WebsockStatus = 1;
        } catch {
            WebsockStatus = -1;
        } finally {
            switch(WebsockStatus)
            {
                case -1:
                    alert("Websocket authentication failed, Please reconnect again.");
                    break;
                default:
                    break;
            }
        }
    }

    function onJesMessage(evt)
    {
        var arrayBufferView = new Uint8Array( evt.data );

        let jes_data = new jpeg_usr_t(arrayBufferView);

        if(jes_data.isKeyframe()) IframeFlag = true;

        if ( FirstWebsockFlag == 1 )
        {
            if (jes_data.codec_type == "H.265")
            {
                alert("H.265 is not surported, Please change another Encoding.");
            }

            if (jes_data.codec_type == "H.264")
            {
                if( jes_data.isKeyframe() )
                {
                    //console.log("isKeyframe !!");
                    mimeType = "video/mp4; codecs=" + jes_data.codec;
                    Converter = new VideoConverter(element, WebSockVideoStreamFps, 1);
                    FirstWebsockFlag = 0;
                }
            }

            if (jes_data.codec_type == "MJPEG")
            {
                $("video").replaceWith("<img id='id_image' src=''></img>");
                FirstWebsockFlag = 0;
            }
        }

        if (jes_data.codec_type == "H.264")
        {
            if(IframeFlag)
            {
                WebsockQueues[1].push(jes_data);
            }
        }
        else if (jes_data.codec_type == "MJPEG")
        {
            $("video").replaceWith("<img id='id_image' src=''></img>");
            var reader<% FwGetParmValue("PortId"); %> = new FileReader();
            reader<% FwGetParmValue("PortId"); %>.onload = function (evt) {
                if (evt.target.readyState == FileReader.DONE) {
                    var url = evt.target.result;
                    document.getElementById("id_image").src = url;
                }
            }

            var arrayBufferView = new Uint8Array(evt.data);
            var blob = new Blob([arrayBufferView], { type: "image/jpeg" });
            reader<% FwGetParmValue("PortId"); %>.readAsDataURL(blob);
            blob = null;
            arrayBufferView = null;
            reader<% FwGetParmValue("PortId"); %> = null;
        }

        DrawArea();

        jes_data = null;
    }

    function onError(evt)
    {

    }

    function doSend(message)
    {
        var bytearray = new Uint8Array( message.length );
        
        websocket.binaryType = 'arraybuffer';
        for ( var idx = 0; idx < message.length; ++idx )
        {
            bytearray[idx] = message[idx].charCodeAt(0);
        }
        websocket.send(bytearray.buffer);
    }

    // holds all our areas
    var areas = [];

    // New, holds the 8 tiny areas that will be our selection handles
    // the selection handles will be in this order:
    // 0  1  2
    // 3     4
    // 5  6  7
    var selectionHandles = [];

    // Hold canvas information
    var canvas;
    var ctx;
    var WIDTH = 354;
    var HEIGHT = 242;

    var isDrag = false;
    var isResizeDrag = false;
    var expectResize = -1; // New, will save the # of the selection handle if the mouse is over one.
    var mx, my; // mouse coordinates

    // when set to true, the canvas will redraw everything

    // The node (if any) being selected.
    // If in the future we want to select multiple objects, this will get turned into an array
    var mSel = null;

    // The selection color and width. Right now we have a red selection with a small width
    var mSelColor = '#CC0000';
    var mSelWidth = 2;
    var mSelBoxColor = 'darkred'; // New for selection areas
    var mSelBoxSize = 6;

    // we use a fake canvas to draw individual shapes for selection testing
    var ghostcanvas;
    var gctx; // fake canvas context

    // since we can drag from anywhere in a node
    // instead of just its x/y corner, we need to save
    // the offset of the mouse when we start dragging.
    var offsetx, offsety;

    // Padding and border style widths for mouse offsets
    var stylePaddingLeft, stylePaddingTop, styleBorderLeft, styleBorderTop;

    // Area object to hold data
    function Area() {
        this.x = 0;
        this.y = 0;
        this.w = 1; // default width and height?
        this.h = 1;
        this.fill = '#444444';
    }

    // New methods on the Area class
    Area.prototype = {
        // we used to have a solo draw function
        // but now each area is responsible for its own drawing
        // mainDraw() will call this with the normal canvas
        // mDown will call this with the ghost canvas with 'black'
        draw: function (context, optionalColor) {
            context.fillStyle = this.fill;
            // We can skip the drawing of elements that have moved off the screen:
            
            if (this.x > WIDTH || this.y > HEIGHT) return;
            if (this.x + this.w < 0 || this.y + this.h < 0) return;

            context.fillRect(this.x, this.y, this.w, this.h);

            // draw selection
            // this is a stroke along the area and also 8 new selection handles
            if (mSel === this) {
                context.strokeStyle = mSelColor;
                context.lineWidth = mSelWidth;
                context.strokeRect(this.x, this.y, this.w, this.h);

                // draw the areas

                var half = mSelBoxSize / 2;

                // 0  1  2
                // 3     4
                // 5  6  7

                // top left, middle, right
                selectionHandles[0].x = this.x - half;
                selectionHandles[0].y = this.y - half;

                selectionHandles[1].x = this.x + this.w / 2 - half;
                selectionHandles[1].y = this.y - half;

                selectionHandles[2].x = this.x + this.w - half;
                selectionHandles[2].y = this.y - half;

                //middle left
                selectionHandles[3].x = this.x - half;
                selectionHandles[3].y = this.y + this.h / 2 - half;

                //middle right
                selectionHandles[4].x = this.x + this.w - half;
                selectionHandles[4].y = this.y + this.h / 2 - half;

                //bottom left, middle, right
                selectionHandles[6].x = this.x + this.w / 2 - half;
                selectionHandles[6].y = this.y + this.h - half;

                selectionHandles[5].x = this.x - half;
                selectionHandles[5].y = this.y + this.h - half;

                selectionHandles[7].x = this.x + this.w - half;
                selectionHandles[7].y = this.y + this.h - half;


                context.fillStyle = mSelBoxColor;
                for (var idx = 0; idx < 8; idx++) {
                    var curHandle = selectionHandles[idx];
                    context.fillRect(curHandle.x, curHandle.y, mSelBoxSize, mSelBoxSize);
                }
            }

        } // end draw

    }

    //Initialize a new Area, add it, and invalidate the canvas
    function addRect(x, y, w, h, fill) {
        var rect = new Area;
        rect.x = x;
        rect.y = y;
        rect.w = w
        rect.h = h;
        rect.fill = fill;
        areas.push(rect);
    }

    // initialize our canvas, add a ghost canvas, set draw loop
    // then add everything we want to intially exist on the canvas
    function DrawArea() {
        canvas = $("#ViewerCanvas", parent.document)[0];
        ctx = canvas.getContext('2d');
        ctx.canvas.width = WIDTH;
        ctx.canvas.height = HEIGHT;

        var WebSockVideo = document.getElementById("id_image");
        ctx.drawImage(WebSockVideo, 0, 0, WIDTH, HEIGHT);

        ghostcanvas = document.createElement('canvas');
        ghostcanvas.width = WIDTH;
        ghostcanvas.height = HEIGHT;
        gctx = ghostcanvas.getContext('2d');

        //fixes a problem where double clicking causes text to get selected on the canvas
        canvas.onselectstart = function () { return false; }

        // fixes mouse co-ordinate problems when there's a border or padding
        // see getMouse for more detail
        if( document.defaultView && document.defaultView.getComputedStyle )
        {
            stylePaddingLeft = parseInt(document.defaultView.getComputedStyle(canvas, null)['paddingLeft'], 10) || 0;
            stylePaddingTop = parseInt(document.defaultView.getComputedStyle(canvas, null)['paddingTop'], 10) || 0;
            styleBorderLeft = parseInt(document.defaultView.getComputedStyle(canvas, null)['borderLeftWidth'], 10) || 0;
            styleBorderTop = parseInt(document.defaultView.getComputedStyle(canvas, null)['borderTopWidth'], 10) || 0;
        }

        // set our events. Up and down are for dragging,
        // double click is for making new areas
        canvas.onmousedown = mDown;
//        canvas.onmouseout = mOut;
        canvas.onmouseup = mUp;
        canvas.onmousemove = mMove;

        // set up the selection handle areas
        for (var idx = 0; idx < 8; idx++) {
            var rect = new Area;
            selectionHandles.push(rect);
        }

        // add custom initialization here:
        if( parent.gFirstStreamFlag == "0" )
        {
            for (var idx = 0; idx < parent.MAX_AREA_NUM; idx++) {
                if (eval("parent.ROI_" + idx + "_RIGHT") != 0) {
                    // add a large green rectangle
                    addRect(parseInt(eval("parent.ROI_" + idx + "_LEFT")), parseInt(eval("parent.ROI_" + idx + "_TOP")), parseInt(eval("parent.ROI_" + idx + "_RIGHT") - eval("parent.ROI_" + idx + "_LEFT")), parseInt(eval("parent.ROI_" + idx + "_BOTTOM") - eval("parent.ROI_" + idx + "_TOP")), 'rgba(0,255,0,0.2)');
                }
            }

            parent.gFirstStreamFlag++;
        }

        // Add stuff you want drawn in the background all the time here

        // draw all areas
        var l = areas.length;
        for (var idx = 0; idx < l; idx++) {
            areas[idx].draw(ctx); // we used to call drawshape, but now each area draws itself
        }
    }

    //wipes the canvas context
    function clear(c) {
        c.clearRect(0, 0, WIDTH, HEIGHT);
    }

    // Happens when the mouse is moving inside the canvas
    function mMove(e) {
        if (isDrag) {
            getMouse(e);

            mSel.x = mx - offsetx;
            mSel.y = my - offsety;

            if(mSel.x < 0 )
                mSel.x = 0;
            if((mSel.x + mSel.w) > WIDTH)
                mSel.x = (WIDTH - mSel.w);
            if(mSel.y < 0 )
                mSel.y = 0;
            if((mSel.y + mSel.h) > HEIGHT)
                mSel.y = (HEIGHT - mSel.h);


            if(mSel.y < 0 || (mSel.y + mSel.h) > HEIGHT)
                console.log("y");

        } else if (isResizeDrag) {
            // time ro resize!
            var mOldx = mSel.x;
            var mOldy = mSel.y;

            // 0  1  2
            // 3     4
            // 5  6  7
            switch (expectResize) {
                case 0:
                    mSel.x = mx;
                    mSel.y = my;
                    mSel.w += mOldx - mx;
                    mSel.h += mOldy - my;
                    break;
                case 1:
                    mSel.y = my;
                    mSel.h += mOldy - my;
                    break;
                case 2:
                    mSel.y = my;
                    mSel.w = mx - mOldx;
                    mSel.h += mOldy - my;
                    break;
                case 3:
                    mSel.x = mx;
                    mSel.w += mOldx - mx;
                    break;
                case 4:
                    mSel.w = mx - mOldx;
                    break;
                case 5:
                    mSel.x = mx;
                    mSel.w += mOldx - mx;
                    mSel.h = my - mOldy;
                    break;
                case 6:
                    mSel.h = my - mOldy;
                    break;
                case 7:
                    mSel.w = mx - mOldx;
                    mSel.h = my - mOldy;
                    break;
            }
        }

        getMouse(e);
        // if there's a selection see if we grabbed one of the selection handles
        if (mSel !== null && !isResizeDrag) {
            for (var idx = 0; idx < 8; idx++) {
                // 0  1  2
                // 3     4
                // 5  6  7

                var curHandle = selectionHandles[idx];

                // we dont need to use the ghost context because
                // selection handles will always be rectangles
                if (mx >= curHandle.x && mx <= curHandle.x + mSelBoxSize &&
                    my >= curHandle.y && my <= curHandle.y + mSelBoxSize) {
                    // we found one!
                    expectResize = idx;

                    switch (idx) {
                        case 0:
                            this.style.cursor = 'nw-resize';
                            break;
                        case 1:
                            this.style.cursor = 'n-resize';
                            break;
                        case 2:
                            this.style.cursor = 'ne-resize';
                            break;
                        case 3:
                            this.style.cursor = 'w-resize';
                            break;
                        case 4:
                            this.style.cursor = 'e-resize';
                            break;
                        case 5:
                            this.style.cursor = 'sw-resize';
                            break;
                        case 6:
                            this.style.cursor = 's-resize';
                            break;
                        case 7:
                            this.style.cursor = 'se-resize';
                            break;
                    }
                    return;
                }

            }
            // not over a selection area, return to normal
            isResizeDrag = false;
            expectResize = -1;
            this.style.cursor = 'auto';
        }

    }

    // Happens when the mouse is clicked in the canvas
    function mDown(e) {
        getMouse(e);

        //we are over a selection area
        if (expectResize !== -1) {
            isResizeDrag = true;
            return;
        }

        var l = areas.length;
        for (var idx = l - 1; idx >= 0; idx--) {
            // draw shape onto ghost context
            areas[idx].draw(gctx, 'black');

            // get image data at the mouse x,y pixel
            var imageData = gctx.getImageData(mx, my, 1, 1);
            var index = (mx + my * imageData.width) * 4;

            // if the mouse pixel exists, select and break
            if (imageData.data[3] > 0) {
                mSel = areas[idx];
                offsetx = mx - mSel.x;
                offsety = my - mSel.y;
                mSel.x = mx - offsetx;
                mSel.y = my - offsety;
                isDrag = true;
                return;
            }

        }
        // havent returned means we have selected nothing
        mSel = null;
    }

    function mUp() {
        isDrag = false;
        isResizeDrag = false;
        expectResize = -1;
    }

    function mOut(e) {
        getMouse(e);

        //we are over a selection area
        if (expectResize !== -1) {
            isResizeDrag = true;
            return;
        }
        
        var l = areas.length;
        for (var idx = l - 1; idx >= 0; idx--) {
            // draw shape onto ghost context
            areas[idx].draw(gctx, 'black');

            // get image data at the mouse x,y pixel
            var imageData = gctx.getImageData(mx, my, 1, 1);
            var index = (mx + my * imageData.width) * 4;

            // if the mouse pixel exists, select and break
            if (imageData.data[3] > 0) {
                mSel = areas[idx];
                offsetx = mx - mSel.x;
                offsety = my - mSel.y;
                mSel.x = mx - offsetx;
                mSel.y = my - offsety;
                isDrag = false;
                return;
            }

        }
        // havent returned means we have selected nothing
        mSel = null;
    }

    // adds a new node
    function New() {
        if (areas.length > (parent.MAX_AREA_NUM - 1)) {
            alert("It is not possible to add area any more.");
            return false;
        }
        else {
            // for this method width and height determine the starting X and Y, too.
            // so I left them as vars in case someone wanted to make them args for something and copy this code
            addRect( 88, 60, 176, 120, 'rgba(0,255,0,0.2)');
        }
    }

    function Delete() {
        var idx;
        var select_idx = -1;
        for( idx = 0; idx < (areas.length); idx++ )
        {
            if( areas[idx] == mSel )
            {
                select_idx = idx;
                break;
            }
        }

        if ( select_idx == -1) {
            alert("Please, select area.");
            return false;
        }
        else {
            areas.splice(select_idx, 1);
        }
    }

    // Sets mx,my to the mouse position relative to the canvas
    // unfortunately this can be tricky, we have to worry about padding and borders
    function getMouse(e) {
        var element = canvas, offsetX = 0, offsetY = 0;

        if (element.offsetParent) {
            do {
                offsetX += element.offsetLeft;
                offsetY += element.offsetTop;
            } while ((element = element.offsetParent));
        }

        // Add padding and border style widths to offset
        offsetX += stylePaddingLeft;
        offsetY += stylePaddingTop;

        offsetX += styleBorderLeft;
        offsetY += styleBorderTop;

        mx = e.pageX - offsetX;
        my = e.pageY - offsetY
    }
</script>
</html>
