let audioContext = null;
let hissGainRange;
let oscGainRange;
let hissGenNode;
let gainNode;
let hissGainParam;
var mediaStreamSource;
let processorNode;

var IP = document.location.hostname;
var PORT = document.location.port;
var wsUri;
if (document.location.protocol == 'https:')
{
    wsUri = "wss://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&PauseTime=0&FwCgiVer=0x0001";
}
else
{
    wsUri = "ws://" + IP + ":" + PORT + "/ws/FlexWatch-WebSocket?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&PauseTime=0&FwCgiVer=0x0001";
}

audio_websocket = new WebSocket(wsUri,["audio"]);
//audio_websocket = new WebSocket(wsUri,["wjes"]);

function gotStream(stream) {
    console.log("111111");
    // window.AudioContext = window.AudioContext || window.webkitAudioContext;
    //  audioContext = new AudioContext({ sampleRate: 8000 });
    // Create an AudioNode from the stream.
    mediaStreamSource = audioContext.createMediaStreamSource(stream);
    // Connect it to the destination to hear yourself (or any other node for processing!)
    mediaStreamSource.connect(processorNode);
    //recorder.connect(audioContext.destination);
    processorNode.connect(audioContext.destination);
    console.log("!!!!!");
}
function errStream(err) {
    console.log("The following error occurred: " + err.name);
}

function _onProcessorInitialized(eventFromProcessor) 
{
        audio_websocket.binaryType = 'blob';
        f32_AudioData = eventFromProcessor.data.audiobuffer;
        var u8_AudioData = new Uint8Array(f32_AudioData.length);
        for (var idx = 0; idx < f32_AudioData.length; idx++) {
          var tmp = Math.max(-1, Math.min(1, f32_AudioData[idx]));
          tmp = tmp < 0 ? (tmp * 0x8000) : (tmp * 0x7FFF);
          u8_AudioData[idx] = tmp;
        }
        //console.log("f32_AudioData.Data = [" + f32_AudioData + " ] f32_AudioData.length [ " + f32_AudioData.length + " ]");
        //console.log("u8_AudioData.Data = [" + u8_AudioData + " ] bytearray.length [ " + u8_AudioData.length + " ]");
        audio_websocket.send(u8_AudioData);
}

async function createHissProcessor() {
    if (!audioContext) {
        try {
            audioContext = new AudioContext({ sampleRate: 8000 });

        } catch (e) {
            console.log("** Error: Unable to create audio context");
            return null;
        }
    }

    try {
        processorNode = new AudioWorkletNode(audioContext, "hiss-generator");
    } catch (e) {
        try {
            console.log("adding...")
            await audioContext.audioWorklet.addModule("hiss-generator.js");
            processorNode = new AudioWorkletNode(audioContext, "hiss-generator");
            processorNode.port.onmessage = _onProcessorInitialized.bind(this);

            navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia;
            navigator.getUserMedia({ audio: true }, gotStream, errStream);

        } catch (e) {
            console.log(`** Error: Unable to create worklet node: ${e}`);
            return null;
        }
    }

    await audioContext.resume();
    return processorNode;
}

async function audioDemoStart() {
    hissGenNode = await createHissProcessor();
    if (!hissGenNode) {
        console.log("** Error: unable to create hiss processor");
        return;
    }
}

window.addEventListener("load", event => {
    document.getElementById("toggle").addEventListener("click", StartAudio);

    hissGainRange = document.getElementById("hiss-gain");
    oscGainRange = document.getElementById("osc-gain");

    hissGainRange.oninput = updateHissGain;
    oscGainRange.oninput = updateOscGain;

    hissGainRange.disabled = true;
    oscGainRange.disabled = true;
});

async function StartAudio(event) {
    if (!audioContext) {
        initWebsock();
        audioDemoStart();
        hissGainRange.disabled = false;
        oscGainRange.disabled = false;
    } else {
        hissGainRange.disabled = true;
        oscGainRange.disabled = true;

        await audioContext.close();
        audioContext = null;
    }
}

function updateHissGain(event) {
    hissGainParam.setValueAtTime(event.target.value, audioContext.currentTime);
}

function updateOscGain(event) {
    gainNode.gain.setValueAtTime(event.target.value, audioContext.currentTime);
}

function initWebsock() {
    audio_websocket.onopen = function(evt) { onOpen(evt) };
//    audio_websocket.onmessage = function(evt) { onMessage(evt) };
    audio_websocket.onclose = function(evt) { onClose(evt) };
    audio_websocket.onerror = function(evt) { onError(evt) };
}

function doSend(message)
{
    audio_websocket.binaryType = 'arraybuffer';
        
    var bytearray = new Uint8Array( message.length );

    var cnt = 0;
    
    for ( var idx = 0; idx < message.length; ++idx ) {
        bytearray[idx] = message[idx].charCodeAt(0);
    }
}

function onOpen(evt) {
    doSend("GET /cgi-bin/fwstream.cgi?ServerId=0&AppKey=0x00000029&PortId=<% FwGetParmValue("PortId"); %>&PauseTime=0&FwCgiVer=0x0001 HTTP/1.1\r\nHost: " + IP + "\r\nConnection: keep-alive\r\nUpgrade-Insecure-Requests: 1\r\nUser-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/89.0.4389.90 Safari/537.36\r\nAccept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9\r\nAccept-Encoding: gzip, deflate\r\nAccept-Language: ko-KR,ko;q=0.9,en-US;q=0.8,en;q=0.7\r\n\r\n");
}

function onMessage(evt)
{

}

function onClose(evt) {

}


function onError(evt)
{

}